

use Digest::SHA1  qw(sha1_base64);

my $password = 'linuxrulz';
my @additive_prev = ();

sub create_access
{
	# Generate a random hash additive, can only be used 1k times.
	my $hash_additive = int(rand 999);
	
	# create a password hash based on the additive and the password.
	my $password_hash = sha1_base64($hash_additive . $password);
	return $hash_additive . '-' . $password_hash;
}

sub get_access
{
	# A simple, yet effective password hashing system.
	# The vulnerability is when altbot is reset, additive_prev is reset.
	# That means that a successful use of this will require a reset of the 
	# password on each reset. That's no problem because create_access has 
	# access to the password also, hahah.
	my ($hash_additive, $password_hash) = @_;
	# check to see if the hash additive has been used before.
	if(grep { $hash_additive eq $_ } @additive_prev)
	{
		print "idiot tried to copy the last password hash.\n";
		0;
	}
	# match the hash they give with the concat of the additive and the password.
	elsif($password_hash eq sha1_base64($hash_additive . $password))
	{
		print "access granted.\n";
		push(@additive_prev, $hash_additive);
		1;
	}
	else
	{
		0;
	}
}

1;
