# remove_grammar.pm
# by Joel R. Voss
# Dec 7, 2005

@articles1 = split /, /, "a, an, the, that, this, those, whatever, either, your";
@articles2 = split /, /, "many, a few, few, several, a couple of, none of the";
@conjunct1 = split /, /, "and, but, or, yet, for, nor, so, with";
@conjunct2 = split /, /, "after, although, as, because, before";
# multi-word doesn't work
# as if, as long as, as though, even if, even though";
@conjunct3 = split /, /, "if, once, since, than, that";
# multi-word doesn't work
#rather than, so that, if only, in order that, now that
@conjunct4 = split /, /, "though, till, unless, until, when, whenever, where, whereas, wherever, while";
@preposit1 = split /, /, "at, on, in, to, for, since, of, about, up, down, by";
# the n't is actually quite important to sentence structure because it negates.
@verb1 = split /, /, "is, are, was, were, it\'s, be, do, does, doesn\'t, don\'t";
@noun1 = split /, /, "you, him, her, I, he, she, it, they, us, we, here, there";
@other1 = split /, /, "except, maybe, probably, sorta, kinda";

sub remove_grammar
{
	my ($indata) = @_;
	chomp $indata;
	#print "got: $indata\n";
	# remove punctuation, the // at the end replaces with nothing.
	$indata =~ s/[\.\,\"\:\;\!\?]//g;
	#print "after: $indata\n";
	@words = split / /, $indata;
	#print "@words\n";
	
	# drop the words that match the words at the top.
	@fnords = grep { &find_grammar } @words;
	$output = "@fnords";
	#print $output . "\n";
	$output;
}

sub find_grammar
{
	my ($word) = $_;
	#print "z: $word\n";
	# case insensitive match
	if(grep { lc($_) eq lc($word) } @articles1) {
		# it is an article, so pitch it.
		0;
	}
	elsif(grep { lc($_) eq lc($word) } @articles2) {
		# it is an article, so pitch it.
		0;
	}
	elsif(grep { lc($_) eq lc($word) } @conjunct1) {
		# it is a conjunction, so pitch it.
		0;
	}
	elsif(grep { lc($_) eq lc($word) } @conjunct2) {
		# it is a conjunction, so pitch it.
		0;
	}
	elsif(grep { lc($_) eq lc($word) } @conjunct3) {
		# it is a conjunction, so pitch it.
		0;
	}
	elsif(grep { lc($_) eq lc($word) } @conjunct4) {
		# it is a conjunction, so pitch it.
		0;
	}
	elsif(grep { lc($_) eq lc($word) } @preposit1) {
		# it is a preposition, so pitch it.
		0;
	}
	elsif(grep { lc($_) eq lc($word) } @verb1) {
		# it is a useless verb, so pitch it.
		0;
	}
	elsif(grep { lc($_) eq lc($word) } @noun1) {
		# it is a useless verb, so pitch it.
		0;
	}
	elsif(grep { lc($_) eq lc($word) } @other1) {
		# it is a useless filler, so pitch it.
		0;
	}
	else {
		# it is either a noun, adjective, verb, adverb, or other, so return it.
		$word;
	}
}

sub equal
{

}

1;
