#!/usr/bin/perl -w

use PFM::linhat_ai1;
use PFM::get_access1;

use Net::IRC;
use strict;

# create the IRC object
my $irc = new Net::IRC;

# Done:
# -r Randomize responses.

# TODO list of options and features to be implemented.
# -l Listen only. do not interject
# -i Accept invitations.
# -j Only talk to owner, Javantea.
# -z Ask for password before you speak.
# -w Search for every word.
# -f Filter out dictionary terms.

# Create a connection object.  You can have more than one "connection" per
# IRC object, but we'll just be working with one.
my $conn = $irc->newconn(
	Server 		=> shift || '127.0.0.1',
	# Note: IRC port is normally 6667, but my firewall won't allow it	
	Port		=> shift || '6667', 
	Nick		=> 'AltBot',
	Ircname		=> 'I am funny.',
	Username	=> 'altsci1'
);

my $msg_counter = 0;
my $speak_wait = 0;

# We're going to add this to the conn hash so we know what channel we
# want to operate in.
$conn->{channel} = shift || '#neg9';

sub on_connect {

	# shift in our connection object that is passed automatically
	my $conn = shift;
  
	# when we connect, join our channel and greet it
	$conn->join($conn->{channel});
	$conn->join('#altsci');
	#$conn->privmsg($conn->{channel}, 'Hello everyone!');
	$conn->{connected} = 1;

}

sub on_join {

	# get our connection object and the event object, which is passed
	# with this event automatically
	my ($conn, $event) = @_;

	# this is the nick that just joined
	my $nick = $event->{nick};
	# say hello to the nick in public
	#$conn->privmsg($conn->{channel}, "Hello, $nick!");
}
	
sub on_part {
	
	# pretty much the same as above

	my ($conn, $event) = @_;

	my $nick = $event->{nick};
	#$conn->privmsg($conn->{channel}, "Goodbye, $nick!");
}

sub on_msg {
	my ($conn, $event) = @_;
	
	# Run on_public with a specific modifier.
	# Msging the bot will always elicit a response.
	
	my $nick = $event->{nick};
	my $data = $event->{args}[0];
	#$conn->privmsg($nick, "Thanks, $nick: $data!");
	$conn->privmsg($nick, "Thanks, but I am a bot.");
}

sub on_public {
	my ($conn, $event) = @_;
	
	my $nick = $event->{nick};
	my $data = $event->{args}[0];
	my $add_data  = 1;
	my $speak_now = 0;
	my $date = "";
	#print Dumper($event);
	
	# 1) Increment the counter.
	$msg_counter += 1;
	if($msg_counter % 10 == 0) { $speak_now = 1; }
	
	# We first check to see if it's public comment to me or another person.
	if ($data =~ /^([^:, ]+)[:, ](.+)/) {
		my $comm_nick;
		my $mydata;
		($comm_nick, $mydata) = ($1, $2);
		if($1 =~/$conn->{_nick}/i) {
			$speak_now = 1;
			# Strip the name off it whether it's from us or not.
			$data = $mydata;
			if($data =~ /shut ?up/) {
				$speak_wait = 50;
			}
			if($data =~ /^permission ([^-]*)-(.*)$/ ) {
				if(get_access($1, $2))
				{
					$speak_wait = 0;
					$speak_now = 1;
				}
			}
		}
	}
	if($speak_wait > 0)
	{
		# we wait N times before we next talk.
		$speak_wait--;
		$speak_now = 0;
	}

	# 2) If it's my time to speak, speak.
	if($speak_now)
	{
		my $found = find_data($data);
		if(length $found > 0)
		{	# $conn->{channel}
			$conn->privmsg($event->{to}[0], "$nick: $found");
		}
		else
		{	# Allow it to try again next time it finds something.
			$msg_counter -= 1;
		}
	}
	# 3) Add the data input to the database.
	if($add_data)
	{
		# Grab the user.
		my @users = get_user($nick);
		if(!@users)
		{
			# If the user doesn't exist, add them for future reference.
			add_user($nick);
		}
		
		# Input the data.
		input_data($nick, $data, $date);
	}

}

use Data::Dumper;

sub default {

        # This is helpful to see what an event returns.  Data::Dumper will
        # recursively reveal the structure of any value
        my ($conn, $event) = @_;
        print Dumper($event);
}
        
# experiment with the cping event, printing out to standard output
$conn->add_handler('cping', \&default);
$conn->add_handler('msg', \&on_msg);
$conn->add_handler('public', \&on_public);

# add event handlers for join and part events
$conn->add_handler('join', \&on_join);
$conn->add_handler('part', \&on_part);

# The end of MOTD (message of the day), numbered 376 signifies we've connect
$conn->add_handler('376', \&on_connect);

# start IRC
$irc->start();

exit_ai();
